# odd_magic_squares.py, http://www.markfarrar.co.uk/msqodd01.htm
# Mark S. Farrar.
while True:
    x = int(raw_input("Give order, odd and >= 3: "))
    if x > 2 and x % 2:
        break

n = [0] * (x*x+1)
z = ((x+1)/2)  + (x-1)
for y in xrange(1, (x*x)+1):
    z1 = z - ((z//x)*x)
    if z1 == 0:
        z1 = x
    z2 = ((z-z1)/x) + 1
    if z1 == x:
        z3 = 1
    else:
        z3 = z1 + 1
    if z2 == 1:
        z4 = x
    else:
        z4 = z2 - 1
    z5 = ((z4-1)*x) + z3
    if z2 == x:
        z6 = 1
    else:
        z6 = 0
    if n[z5] != 0:
        z3 = z1
        z4 = (z2+1) - (z6*x)
    z5 = ((z4-1)*x) + z3
    n[z5] = y
    z = z5

# Assert correct result
m = [n[1+i:1+i+x] for i in xrange(0,x*x,x)]
assert len( set(sum(row) for row in m)) == 1
assert len( set(sum(row) for row in zip(*m))) == 1
d1 = [m[i][i] for i in xrange(len(m))]
d2 = [m[len(m)-i-1][i] for i in xrange(len(m))]
assert sum(d1) == sum(d2) == sum(m[0])

print "The following magic square adds up to", ((x*x*x)+x)/2, "\n"
for b in xrange(1, x*x+1):
    print str(n[b]).rjust(5),
    if not (b % x):
        print